using System;
using System.Drawing;
using System.Collections.Generic;
using System.Text;

using TTDotNet.Engine.GUI.Windows;
using TTDotNet.Util;
using TTDotNet.Engine.ThreeDEngine;

namespace TTDotNet.Engine.GUI
{
    public class ButtonBar : Window
    {
        public ButtonBar(PointF screenLocation)
        {
            SetScreenRectangle(new RectangleF(screenLocation, new SizeF(64, 64)));
            SetupButtons();
            AlwaysOnTop = true;
        }

        private void SetupButtons()
        {
            SetupRoadConc();
        }

        private void SetupRoadConc()
        {
            int controlNum = 0;

            windowControls[controlNum++] = new GameButton(new RectangleF(new PointF(0, 0), new SizeF(64, 64)), "", 1, Color.Black, "Arial",
                                            Game.textureCacher.LoadTexture("artwork/128/Road.jpg"), Game.textureCacher.LoadTexture("artwork/128/Road_down.jpg"));
            windowControls[0].OnControl += new Control.ControlDelegate(CreateRoadConcWindow);
        }

        private void CreateRoadConcWindow(object data, object tag)
        {
            Game.newGUI.OpenNewWindow(new RoadConcWindow(new PointF(300, 300)));
        }

    }
}
