struct VertexToPixel
{
    float4 Position     : POSITION;
    float2 TexCoords    : TEXCOORD0;
};

struct PixelToFrame
{
    float4 Color : COLOR0;
};

float4x4 xViewProjection;
float4x4 texMatrix	:	TextureMatrix;



 Texture xColoredTexture;

sampler ColoredTextureSampler = sampler_state { texture = <xColoredTexture> ; magfilter =anisotropic; minfilter =anisotropic; mipfilter=anisotropic; AddressU = mirror; AddressV = mirror;};



 VertexToPixel SimplestVertexShader( float4 inPos : POSITION, float2 inTexCoords : TEXCOORD0)
{
    VertexToPixel Output = (VertexToPixel)0;
    
    Output.Position = mul(inPos, xViewProjection);


    Output.TexCoords = mul(texMatrix, inTexCoords);

    
    return Output;    
}

PixelToFrame OurFirstPixelShader(VertexToPixel PSIn)
{
    PixelToFrame Output = (PixelToFrame)0;

    Output.Color = tex2D(ColoredTextureSampler, PSIn.TexCoords);
     
    return Output;
}

technique Simplest
{
    pass Pass0
    {        
        VertexShader = compile vs_3_0 SimplestVertexShader();
        PixelShader = compile ps_3_0 OurFirstPixelShader();
    }
}